## mlpack 3.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.10)
project(mlpack C CXX)

include(CMake/cotire.cmake)

# First, define all the compilation options.
# We default to debugging mode for developers.
option(DEBUG "Compile with debugging information." OFF)
option(PROFILE "Compile with profiling information." OFF)
option(ARMA_EXTRA_DEBUG "Compile with extra Armadillo debugging symbols." OFF)
option(MATLAB_BINDINGS "Compile MATLAB bindings if MATLAB is found." OFF)
option(TEST_VERBOSE "Run test cases with verbose output." OFF)
option(BUILD_TESTS "Build tests." ON)
option(BUILD_CLI_EXECUTABLES "Build command-line executables." ON)
option(BUILD_PYTHON_BINDINGS "Build Python bindings." ON)
option(BUILD_SHARED_LIBS
    "Compile shared libraries (if OFF, static libraries are compiled)." ON)
option(BUILD_WITH_COVERAGE
    "Build with support for code coverage tools (gcc only)." OFF)
option(MATHJAX
    "Use MathJax for HTML Doxygen output (disabled by default)." OFF)
option(FORCE_CXX11
    "Don't check that the compiler supports C++11, just assume it.  Make sure to specify any necessary flag to enable C++11 as part of CXXFLAGS." OFF)
enable_testing()

# Currently Python bindings aren't known to build successfully on Windows, so
# set BUILD_PYTHON_BINDINGS to OFF when the platform is Windows.
if (WIN32)
  option(BUILD_PYTHON_BINDINGS "Build Python bindings." OFF)
  message(WARNING "By default Python bindings are not compiled for Windows because they are not known to work.  Set BUILD_PYTHON_BINDINGS to ON if you want them built.")
endif()

# Ensure that we have a C++11 compiler.  In newer versions of CMake, this is
# done with target_compile_features() when the mlpack library target is added in
# src/mlpack/CMakeLists.txt.
if ((${CMAKE_MAJOR_VERSION} LESS 3 OR
    (${CMAKE_MAJOR_VERSION} EQUAL 3 AND ${CMAKE_MINOR_VERSION} LESS 1))
    AND NOT FORCE_CXX11)
  # Older versions of CMake do not support target_compile_features(), so we have
  # to use something kind of hacky.
  include(CMake/CXX11.cmake)
  check_for_cxx11_compiler(HAS_CXX11)
  if(NOT HAS_CXX11)
    message(FATAL_ERROR "No C++11 compiler available!")
  endif()
  enable_cxx11()
else()
  # set required standard to c++11
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif ()
# Otherwise, we may have to set the C++11 mode after the mlpack target is
# defined.

# Include modules in the CMake directory.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake")

# This is as of yet unused.
#option(PGO "Use profile-guided optimization if not a debug build" ON)

# Set the CFLAGS and CXXFLAGS depending on the options the user specified.
# Only GCC-like compilers support -Wextra, and other compilers give tons of
# output for -Wall, so only -Wall and -Wextra on GCC.
if(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  # Ensure that we can't compile with clang 3.4, since this causes strange
  # issues.
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.5)
    message(FATAL_ERROR "mlpack does not build correctly with clang < 3.5.  "
        "Please upgrade your compiler and reconfigure mlpack.")
  endif ()

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -ftemplate-depth=1000")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra")
endif()

# These support libraries are used if we need to link against something
# specific.  This list is a subset of MLPACK_LIBRARIES.
set(COMPILER_SUPPORT_LIBRARIES "")

# If we are using MSVC, we need /bigobj.
if (MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
endif ()

# If using clang, we have to link against libc++ depending on the
# OS (at least on some systems). Further, gcc sometimes optimizes calls to
# math.h functions, making -lm unnecessary with gcc, but it may still be
# necessary with clang.
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  if (APPLE)
    # Detect OS X version. Use '/usr/bin/sw_vers -productVersion' to
    # extract V from '10.V.x'.
    exec_program(/usr/bin/sw_vers ARGS
        -productVersion OUTPUT_VARIABLE MACOSX_VERSION_RAW)
    string(REGEX REPLACE
        "10\\.([0-9]+).*" "\\1"
        MACOSX_VERSION
        "${MACOSX_VERSION_RAW}")

     # OSX Lion (10.7) and OS X Mountain Lion (10.8) doesn't automatically
     # select the right stdlib.
    if(${MACOSX_VERSION} LESS 9)
      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
      set(CMAKE_SHARED_LINKER_FLAGS
          "${CMAKE_SHARED_LINKER_FLAGS} -stdlib=libc++")
      set(CMAKE_MODULE_LINKER_FLAGS
          "${CMAKE_MODULE_LINKER_FLAGS} -stdlib=libc++")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
     endif()
  endif()

  # Link everything with -lm.
  set(COMPILER_SUPPORT_LIBRARIES ${COMPILER_SUPPORT_LIBRARIES} "m")
  set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} "m")
  # Use -pthread, but not on OS X.
  if (NOT APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  endif ()
endif()

# Setup build for test coverage
if(BUILD_WITH_COVERAGE)
  # Currently coverage only works with GNU g++
  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # Find gcov and lcov
    find_program(GCOV gcov)
    find_program(LCOV lcov)

    if(NOT GCOV)
      message(FATAL_ERROR
          "gcov not found! gcov is required when BUILD_WITH_COVERAGE=ON.")
    endif()

    set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} "supc++")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -fno-inline -fno-inline-small-functions -fno-default-inline -fprofile-arcs -fkeep-inline-functions")
    message(STATUS "Adding debug compile options for code coverage.")
    # Remove optimizations for better line coverage
    set(DEBUG ON)

    if(LCOV)
      configure_file(CMake/mlpack_coverage.in mlpack_coverage @ONLY)
      add_custom_target(mlpack_coverage DEPENDS mlpack_test COMMAND ${PROJECT_BINARY_DIR}/mlpack_coverage)
    else()
      message(WARNING "'lcov' not found; local coverage report is disabled. "
          "Install 'lcov' and rerun cmake to generate local coverage report.")
    endif()
  else()
    message(FATAL_ERROR "BUILD_WITH_COVERAGE can only work with GNU environment.")
  endif()
endif()

# For clock_gettime().
if (UNIX AND NOT APPLE AND NOT HAIKU)
  set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} "rt")
endif ()

# Debugging CFLAGS.  Turn optimizations off; turn debugging symbols on.
if(DEBUG)
  if (NOT MSVC)
    add_definitions(-DDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 -ftemplate-backtrace-limit=0")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -g -O0")
  endif()

  # mlpack uses it's own mlpack::backtrace class based on Binary File Descriptor
  # <bfd.h> and linux Dynamic Loader <libdl.h> and more portable version in future
  if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    find_package(Bfd)
    find_package(LibDL)
    if(LIBBFD_FOUND AND LIBDL_FOUND)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -rdynamic")
      set(MLPACK_INCLUDE_DIRS ${MLPACK_INCLUDE_DIRS} ${LIBBFD_INCLUDE_DIRS}
          ${LIBDL_INCLUDE_DIRS})
      set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} ${LIBBFD_LIBRARIES}
          ${LIBDL_LIBRARIES})
      add_definitions(-DHAS_BFD_DL)
    else()
      message(WARNING "No libBFD and/or libDL has been found!")
    endif()
  endif()
else()
  add_definitions(-DARMA_NO_DEBUG)
  add_definitions(-DNDEBUG)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -O3")
endif()

# Profiling CFLAGS.  Turn profiling information on.
if(CMAKE_COMPILER_IS_GNUCC AND PROFILE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
endif()

# If the user asked for running test cases with verbose output, turn that on.
if(TEST_VERBOSE)
  add_definitions(-DTEST_VERBOSE)
endif()

# If the user asked for extra Armadillo debugging output, turn that on.
if(ARMA_EXTRA_DEBUG)
  add_definitions(-DARMA_EXTRA_DEBUG)
endif()

# Now, find the libraries we need to compile against.  Several variables can be
# set to manually specify the directory in which each of these libraries
# resides.
#   ARMADILLO_LIBRARY - location of libarmadillo.so / armadillo.lib
#   ARMADILLO_INCLUDE_DIR - directory containing <armadillo>
#   ARMADILLO_INCLUDE_DIRS - directories necessary for Armadillo includes
#   BOOST_ROOT - root of Boost installation
#   BOOST_INCLUDEDIR - include directory for Boost
#   BOOST_LIBRARYDIR - library directory for Boost
#   MATHJAX_ROOT - root of MathJax installation

find_package(Armadillo 6.500.0 REQUIRED)

# If Armadillo was compiled without ARMA_64BIT_WORD and we are on a 64-bit
# system (where size_t will be 64 bits), suggest to the user that they should
# compile Armadillo with 64-bit words.  Note that with Armadillo 5.000.0 and
# newer, ARMA_64BIT_WORD is enabled by default.
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  # Check the version, to see if ARMA_64BIT_WORD is enabled by default.
  set(ARMA_HAS_64BIT_WORD 0)
  if(NOT (${ARMADILLO_VERSION_MAJOR} LESS 5))
    set(ARMA_HAS_64BIT_WORD 1)
  else()
    # Can we open the configuration file?  If not, issue a warning.
    if(NOT EXISTS "${ARMADILLO_INCLUDE_DIR}/armadillo_bits/config.hpp")
      message(WARNING "Armadillo configuration file "
          "(${ARMADILLO_INCLUDE_DIR}/armadillo_bits/config.hpp) does not exist!")
    else()
      # We are on a 64-bit system.  Does Armadillo have ARMA_64BIT_WORD enabled?
      file(READ "${ARMADILLO_INCLUDE_DIR}/armadillo_bits/config.hpp" ARMA_CONFIG)
      string(REGEX MATCH
          "[\r\n][ ]*#define ARMA_64BIT_WORD"
          ARMA_HAS_64BIT_WORD_PRE
          "${ARMA_CONFIG}")

      string(LENGTH "${ARMA_HAS_64BIT_WORD_PRE}" ARMA_HAS_64BIT_WORD)
    endif()
  endif()

  if(ARMA_HAS_64BIT_WORD EQUAL 0)
    message(WARNING "This is a 64-bit system, but Armadillo was compiled "
        "without 64-bit index support.  Consider recompiling Armadillo with "
        "ARMA_64BIT_WORD to enable 64-bit indices (large matrix support). "
        "mlpack will still work without ARMA_64BIT_WORD defined, but will not "
        "scale to matrices with more than 4 billion elements.")
  endif()
else()
  # If we are on a 32-bit system, we must manually specify the size of the word
  # to be 32 bits, since otherwise Armadillo will produce a warning that it is
  # disabling 64-bit support.
  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    add_definitions(-DARMA_32BIT_WORD)
  endif ()
endif()

# On Windows, Armadillo should be using LAPACK and BLAS but we still need to
# link against it.  We don't want to use the FindLAPACK or FindBLAS modules
# because then we are required to have a FORTRAN compiler (argh!) so we will try
# and find LAPACK and BLAS ourselves, using a slightly modified variant of the
# script Armadillo uses to find these.
if (WIN32)
  find_library(LAPACK_LIBRARY
      NAMES lapack liblapack lapack_win32_MT lapack_win32
      PATHS "C:/Program Files/Armadillo"
      PATH_SUFFIXES "examples/lib_win32/")

  if (NOT LAPACK_LIBRARY)
    message(FATAL_ERROR "Cannot find LAPACK library (.lib)!")
  endif ()

  find_library(BLAS_LIBRARY
      NAMES blas libblas blas_win32_MT blas_win32
      PATHS "C:/Program Files/Armadillo"
      PATH_SUFFIXES "examples/lib_win32/")

  if (NOT BLAS_LIBRARY)
    message(FATAL_ERROR "Cannot find BLAS library (.lib)!")
  endif ()

  # Piggyback LAPACK and BLAS linking into Armadillo link.
  set(ARMADILLO_LIBRARIES
       ${ARMADILLO_LIBRARIES} ${BLAS_LIBRARY} ${LAPACK_LIBRARY})
endif ()

# Include directories for the previous dependencies.
set(MLPACK_INCLUDE_DIRS ${MLPACK_INCLUDE_DIRS} ${ARMADILLO_INCLUDE_DIRS})
set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} ${ARMADILLO_LIBRARIES})

# Unfortunately this configuration variable is necessary and will need to be
# updated as time goes on and new versions are released.
set(Boost_ADDITIONAL_VERSIONS
  "1.66.0" "1.66"
  "1.65.1" "1.65.0" "1.65"
  "1.64.1" "1.64.0" "1.64"
  "1.63.1" "1.63.0" "1.63"
  "1.62.1" "1.62.0" "1.62"
  "1.61.1" "1.61.0" "1.61"

=== src/mlpack/tests/CMakeLists.txt ===
# mlpack test executable.
add_executable(mlpack_test
  activation_functions_test.cpp
  ada_delta_test.cpp
  ada_grad_test.cpp
  adaboost_test.cpp
  adam_test.cpp
  akfn_test.cpp
  aknn_test.cpp
  ann_layer_test.cpp
  arma_extend_test.cpp
  armadillo_svd_test.cpp
  async_learning_test.cpp
  aug_lagrangian_test.cpp
  augmented_rnns_tasks_test.cpp
  binarize_test.cpp
  block_krylov_svd_test.cpp
  cf_test.cpp
  cli_binding_test.cpp
  cli_test.cpp
  cmaes_test.cpp
  cne_test.cpp
  convolution_test.cpp
  convolutional_network_test.cpp
  cosine_tree_test.cpp
  cv_test.cpp
  dbscan_test.cpp
  decision_stump_test.cpp
  decision_tree_test.cpp
  det_test.cpp
  distribution_test.cpp
  drusilla_select_test.cpp
  emst_test.cpp
  fastmks_test.cpp
  feedforward_network_test.cpp
  frankwolfe_test.cpp
  function_test.cpp
  gmm_test.cpp
  gradient_clipping_test.cpp
  gradient_descent_test.cpp
  hmm_test.cpp
  hoeffding_tree_test.cpp
  hpt_test.cpp
  hyperplane_test.cpp
  imputation_test.cpp
  init_rules_test.cpp
  katyusha_test.cpp
  iqn_test.cpp
  kernel_pca_test.cpp
  kernel_test.cpp
  kernel_traits_test.cpp
  kfn_test.cpp
  kmeans_test.cpp
  knn_test.cpp
  krann_search_test.cpp
  ksinit_test.cpp
  lars_test.cpp
  lbfgs_test.cpp
  lin_alg_test.cpp
  line_search_test.cpp
  linear_regression_test.cpp
  load_save_test.cpp
  local_coordinate_coding_test.cpp
  log_test.cpp
  logistic_regression_test.cpp
  lrsdp_test.cpp
  lsh_test.cpp
  math_test.cpp
  matrix_completion_test.cpp
  maximal_inputs_test.cpp
  mean_shift_test.cpp
  metric_test.cpp
  mlpack_test.cpp
  mock_categorical_data.hpp
  momentum_sgd_test.cpp
  nbc_test.cpp
  nca_test.cpp
  nesterov_momentum_sgd_test.cpp
  nmf_test.cpp
  nystroem_method_test.cpp
  octree_test.cpp
  parallel_sgd_test.cpp
  pca_test.cpp
  perceptron_test.cpp
  prefixedoutstream_test.cpp
  proximal_test.cpp
  python_binding_test.cpp
  q_learning_test.cpp
  qdafn_test.cpp
  quic_svd_test.cpp
  radical_test.cpp
  random_forest_test.cpp
  random_test.cpp
  randomized_svd_test.cpp
  range_search_test.cpp
  rectangle_tree_test.cpp
  recurrent_network_test.cpp
  regularized_svd_test.cpp
  rl_components_test.cpp
  rmsprop_test.cpp
  sa_test.cpp
  sarah_test.cpp
  scd_test.cpp
  sdp_primal_dual_test.cpp
  serialization.cpp
  serialization.hpp
  serialization_test.cpp
  sfinae_test.cpp
  sgd_test.cpp
  sgdr_test.cpp
  smorms3_test.cpp
  snapshot_ensembles.cpp
  softmax_regression_test.cpp
  sort_policy_test.cpp
  spalera_sgd_test.cpp
  sparse_autoencoder_test.cpp
  sparse_coding_test.cpp
  spill_tree_test.cpp
  split_data_test.cpp
  svd_batch_test.cpp
  svd_incremental_test.cpp
  svrg_test.cpp
  termination_policy_test.cpp
  test_function_tools.hpp
  test_tools.hpp
  timer_test.cpp
  tree_test.cpp
  tree_traits_test.cpp
  ub_tree_test.cpp
  union_find_test.cpp
  vantage_point_tree_test.cpp
  main_tests/test_helper.hpp
  main_tests/emst_test.cpp
  main_tests/adaboost_test.cpp
  main_tests/cf_test.cpp
  main_tests/dbscan_test.cpp
  main_tests/decision_tree_test.cpp
  main_tests/decision_stump_test.cpp
  main_tests/linear_regression_test.cpp
  main_tests/logistic_regression_test.cpp
  main_tests/mean_shift_test.cpp
  main_tests/nbc_test.cpp
  main_tests/nmf_test.cpp
  main_tests/pca_test.cpp
  main_tests/perceptron_test.cpp
  main_tests/preprocess_binarize_test.cpp
  main_tests/preprocess_imputer_test.cpp
  main_tests/preprocess_split_test.cpp
  main_tests/random_forest_test.cpp
  main_tests/softmax_regression_test.cpp
  main_tests/sparse_coding_test.cpp
  main_tests/kmeans_test.cpp
  main_tests/hoeffding_tree_test.cpp
  main_tests/hmm_viterbi_test.cpp
  main_tests/hmm_train_test.cpp
  main_tests/hmm_loglik_test.cpp
  main_tests/hmm_generate_test.cpp
  main_tests/hmm_test_utils.hpp
)

# Link dependencies of test executable.
target_link_libraries(mlpack_test
  mlpack
  ${BOOST_unit_test_framework_LIBRARY}
)

set_target_properties(mlpack_test PROPERTIES COTIRE_CXX_PREFIX_HEADER_INIT "../core.hpp")
cotire(mlpack_test)

# Copy test data into right place.
add_custom_command(TARGET mlpack_test
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/data/
      ${PROJECT_BINARY_DIR}
)
add_custom_command(TARGET mlpack_test
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E tar xjpf mnist_first250_training_4s_and_9s.tar.bz2
  WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
)

# The list of long running parallel tests
set(parallel_tests
  "AsyncLearningTest"
  "SdpPrimalDualTest;SVDIncrementalTest;SVDBatchTest;"
  "LocalCoordinateCodingTest;FeedForwardNetworkTest;SparseAutoencoderTest;"
  "GMMTest;CFTest;ConvolutionalNetworkTest;HMMTest;LARSTest;"
  "LogisticRegressionTest")

# Add tests to the testing framework
# Get the list of sources from the test target
get_target_property(test_sources mlpack_test SOURCES)

# Go through the list of test sources and parse the test suite name
foreach(test_file ${test_sources})
  # Regex for parsing files with AUTO_TEST_SUITE
  file(STRINGS ${test_file} test_suite REGEX "BOOST_AUTO_TEST_SUITE\\(.*")
  if(NOT "${test_suite}" STREQUAL "")
    # Get the substring of test_suite within brackets in test_name
    string(REGEX MATCH "\\(.*\\)" test_name ${test_suite})
    # Get the substring excluding the brackets, by calculating the indices
    string(LENGTH ${test_name} end_idx)
    math(EXPR end_idx "${end_idx} - 2")
    string(SUBSTRING ${test_name} "1" ${end_idx} test)
    # Add the test to the testing tool, test is the name of the test suite
    add_test(NAME ${test} COMMAND mlpack_test -t ${test} WORKING_DIRECTORY
      ${CMAKE_BINARY_DIR})
  endif()
  # Regex for parsing files with FIXTURE_TEST_SUITE similarly
  file(STRINGS ${test_file} test_suite REGEX "BOOST_FIXTURE_TEST_SUITE\\(.*,")
  if(NOT "${test_suite}" STREQUAL "")
    # Get the substring of test_suite within brackets and comma in test_name
    string(REGEX MATCH "\\(.*," test_name ${test_suite})
    string(LENGTH ${test_name} end_idx)
    math(EXPR end_idx "${end_idx} - 2")
    string(SUBSTRING ${test_name} "1" ${end_idx} test)
    add_test(NAME ${test} COMMAND mlpack_test -t ${test} WORKING_DIRECTORY
      ${CMAKE_BINARY_DIR})
  endif()
endforeach()

# Use RUN_SERIAL for long running parallel tests
set_tests_properties(${parallel_tests} PROPERTIES RUN_SERIAL TRUE)

=== src/mlpack/core/optimizers/CMakeLists.txt ===
set(DIRS
  ada_delta
  ada_grad
  adam
  aug_lagrangian
  cmaes
  cne
  fw
  gradient_descent
  grid_search
  katyusha
  iqn
  lbfgs
  line_search
  problems
  proximal
  parallel_sgd
  rmsprop
  sa
  sarah
  scd
  sdp
  sgd
  sgdr
  smorms3
  svrg
  spalera_sgd
)

foreach(dir ${DIRS})
  add_subdirectory(${dir})
endforeach()

set(SOURCES
  function.hpp
)

set(DIR_SRCS)
foreach(file ${SOURCES})
  set(DIR_SRCS ${DIR_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/${file})
endforeach()

set(MLPACK_SRCS ${MLPACK_SRCS} ${DIR_SRCS} PARENT_SCOPE)

=== src/mlpack/methods/ann/CMakeLists.txt ===
# Define the files we need to compile
# Anything not in this list will not be compiled into mlpack.
set(SOURCES
  ffn.hpp
  ffn_impl.hpp
  rnn.hpp
  rnn_impl.hpp
)

add_subdirectory(visitor)
add_subdirectory(activation_functions)
add_subdirectory(init_rules)
add_subdirectory(layer)
add_subdirectory(convolution_rules)
add_subdirectory(augmented)

# Add directory name to sources.
set(DIR_SRCS)
foreach(file ${SOURCES})
  set(DIR_SRCS ${DIR_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/${file})
endforeach()
# Append sources (with directory name) to list of all mlpack sources (used at
# the parent scope).
set(MLPACK_SRCS ${MLPACK_SRCS} ${DIR_SRCS} PARENT_SCOPE)

=== src/mlpack/methods/ann/init_rules/CMakeLists.txt ===
# Define the files we need to compile
# Anything not in this list will not be compiled into mlpack.
set(SOURCES
  const_init.hpp
  gaussian_init.hpp
  init_rules_traits.hpp
  kathirvalavakumar_subavathi_init.hpp
  network_init.hpp
  nguyen_widrow_init.hpp
  oivs_init.hpp
  orthogonal_init.hpp
  random_init.hpp
  glorot_init.hpp
)

# Add directory name to sources.
set(DIR_SRCS)
foreach(file ${SOURCES})
  set(DIR_SRCS ${DIR_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/${file})
endforeach()
# Append sources (with directory name) to list of all mlpack sources (used at
# the parent scope).
set(MLPACK_SRCS ${MLPACK_SRCS} ${DIR_SRCS} PARENT_SCOPE)

=== src/mlpack/methods/ann/layer/CMakeLists.txt ===
# Define the files we need to compile
# Anything not in this list will not be compiled into mlpack.
set(SOURCES
  add.hpp
  add_impl.hpp
  add_merge.hpp
  add_merge_impl.hpp
  base_layer.hpp
  bilinear_interpolation.hpp
  bilinear_interpolation_impl.hpp
  batch_norm.hpp
  batch_norm_impl.hpp
  concat.hpp
  concat_impl.hpp
  concat_performance.hpp
  concat_performance_impl.hpp
  constant.hpp
  constant_impl.hpp
  convolution.hpp
  convolution_impl.hpp
  cross_entropy_error.hpp
  cross_entropy_error_impl.hpp
  dropconnect.hpp
  dropconnect_impl.hpp
  dropout.hpp
  dropout_impl.hpp
  elu.hpp
  elu_impl.hpp
  fast_lstm.hpp
  fast_lstm_impl.hpp
  glimpse.hpp
  glimpse_impl.hpp
  gru.hpp
  gru_impl.hpp
  hard_tanh.hpp
  hard_tanh_impl.hpp
  join.hpp
  join_impl.hpp
  layer.hpp
  layer_traits.hpp
  layer_types.hpp
  leaky_relu.hpp
  leaky_relu_impl.hpp
  linear.hpp
  linear_impl.hpp
  linear_no_bias.hpp
  linear_no_bias_impl.hpp
  log_softmax.hpp
  log_softmax_impl.hpp
  lookup.hpp
  lookup_impl.hpp
  lstm.hpp
  lstm_impl.hpp
  max_pooling.hpp
  max_pooling_impl.hpp
  mean_pooling.hpp
  mean_pooling_impl.hpp
  mean_squared_error.hpp
  mean_squared_error_impl.hpp
  multiply_constant.hpp
  multiply_constant_impl.hpp
  negative_log_likelihood.hpp
  negative_log_likelihood_impl.hpp
  parametric_relu.hpp
  parametric_relu_impl.hpp
  recurrent.hpp
  recurrent_impl.hpp
  recurrent_attention.hpp
  recurrent_attention_impl.hpp
  reinforce_normal.hpp
  reinforce_normal_impl.hpp
  sigmoid_cross_entropy_error.hpp
  sigmoid_cross_entropy_error_impl.hpp
  select.hpp
  select_impl.hpp
  sequential.hpp
  sequential_impl.hpp
  vr_class_reward.hpp
  vr_class_reward_impl.hpp
)

# Add directory name to sources.
set(DIR_SRCS)
foreach(file ${SOURCES})
  set(DIR_SRCS ${DIR_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/${file})
endforeach()
# Append sources (with directory name) to list of all mlpack sources (used at
# the parent scope).
set(MLPACK_SRCS ${MLPACK_SRCS} ${DIR_SRCS} PARENT_SCOPE)

=== src/mlpack/methods/reinforcement_learning/environment/CMakeLists.txt ===
# Define the files we need to compile
# Anything not in this list will not be compiled into mlpack.
set(SOURCES
  mountain_car.hpp
  cart_pole.hpp
)

# Add directory name to sources.
set(DIR_SRCS)
foreach(file ${SOURCES})
  set(DIR_SRCS ${DIR_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/${file})
endforeach()
# Append sources (with directory name) to list of all mlpack sources (used at
# the parent scope).
set(MLPACK_SRCS ${MLPACK_SRCS} ${DIR_SRCS} PARENT_SCOPE)

=== debian/changelog ===
mlpack (3.0.0-2) unstable; urgency=medium

  * Remove now-unused lintian override
  * Add Armadillo debian/copyright stanza
  * Properly fix man pages by patching generator
  * Patch tiny spelling error

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 05 Apr 2018 10:17:35 +0100

mlpack (3.0.0-1) unstable; urgency=medium

  * New upstream version
  * Debhelper 11
  * Bump standards version
  * Swizzle packaging repo to salsa
  * Use latexmk --pdf to build manual to avoid problematic ps2pdf
  * Secure some URLs
  * Adjust html manual installation, new subdir search/
  * Remove now-unnecessary chrpath --delete
  * Adjust man page installation to upstream changes
    - section 3 gone
    - section 1 for executables, install into -bin package
  * Refresh debian/copyright from COPYRIGHT.txt
  * Add UPDATING.txt and CONTRIBUTING.md to doc package
  * Install HISTORY.md as upstream changelog
  * Bump .soname per upstream

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 04 Apr 2018 09:16:00 +0100

## mlpack 3.0.1

=== src/mlpack/tests/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
   async_learning_test.cpp
   aug_lagrangian_test.cpp
   augmented_rnns_tasks_test.cpp
+  bigbatch_sgd_test.cpp
   binarize_test.cpp
   block_krylov_svd_test.cpp
   cf_test.cpp
@@ -63,6 +64,7 @@
   local_coordinate_coding_test.cpp
   log_test.cpp
   logistic_regression_test.cpp
+  loss_functions_test.cpp
   lrsdp_test.cpp
   lsh_test.cpp
   math_test.cpp
@@ -132,6 +134,7 @@
   main_tests/test_helper.hpp
   main_tests/emst_test.cpp
   main_tests/adaboost_test.cpp
+  main_tests/approx_kfn_test.cpp
   main_tests/cf_test.cpp
   main_tests/dbscan_test.cpp
   main_tests/decision_tree_test.cpp

=== src/mlpack/methods/ann/layer/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,8 @@
   add_impl.hpp
   add_merge.hpp
   add_merge_impl.hpp
+  alpha_dropout.hpp
+  alpha_dropout_impl.hpp
   base_layer.hpp
   bilinear_interpolation.hpp
   bilinear_interpolation_impl.hpp
@@ -18,8 +20,6 @@
   constant_impl.hpp
   convolution.hpp
   convolution_impl.hpp
-  cross_entropy_error.hpp
-  cross_entropy_error_impl.hpp
   dropconnect.hpp
   dropconnect_impl.hpp
   dropout.hpp
@@ -28,6 +28,8 @@
   elu_impl.hpp
   fast_lstm.hpp
   fast_lstm_impl.hpp
+  flexible_relu.hpp
+  flexible_relu_impl.hpp
   glimpse.hpp
   glimpse_impl.hpp
   gru.hpp
@@ -55,8 +57,6 @@
   max_pooling_impl.hpp
   mean_pooling.hpp
   mean_pooling_impl.hpp
-  mean_squared_error.hpp
-  mean_squared_error_impl.hpp
   multiply_constant.hpp
   multiply_constant_impl.hpp
   negative_log_likelihood.hpp
@@ -69,8 +69,6 @@
   recurrent_attention_impl.hpp
   reinforce_normal.hpp
   reinforce_normal_impl.hpp
-  sigmoid_cross_entropy_error.hpp
-  sigmoid_cross_entropy_error_impl.hpp
   select.hpp
   select_impl.hpp
   sequential.hpp

=== src/mlpack/methods/reinforcement_learning/environment/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,8 @@
 set(SOURCES
   mountain_car.hpp
   cart_pole.hpp
+  continuous_mountain_car.hpp
+  acrobat.hpp
 )
 
 # Add directory name to sources.

=== debian/changelog ===
mlpack (3.0.1-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 20 May 2018 23:32:18 +0100

=== debian/control ===
Source: mlpack
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: cmake, debhelper (>= 11), dh-exec,
		pkg-config,
		chrpath,
		libboost-math-dev,
		libboost-program-options-dev,
		libboost-random-dev,
		libboost-test-dev,
		libboost-serialization-dev,
		libxml2-dev,
		libarmadillo-dev,
		txt2man,
		doxygen, doxygen-latex, graphviz, latexmk
Standards-Version: 4.1.3
Homepage: https://www.mlpack.org/
Vcs-Git: https://salsa.debian.org/science-team/mlpack.git
Vcs-Browser: https://salsa.debian.org/science-team/mlpack

Package: libmlpack-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, libmlpack3 (= ${binary:Version}),
	 libarmadillo-dev (>= 1:3.6.0), liblapack-dev, libxml2-dev, libboost-dev
Suggests: mlpack-doc
Description: intuitive, fast, scalable C++ machine learning library (development libs)
 This package contains the mlpack Library development files.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: libmlpack3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: intuitive, fast, scalable C++ machine learning library (runtime library)
 This package contains the mlpack Library runtime files.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: mlpack-bin
Section: science
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, libmlpack3 (>= ${binary:Version})
Description: intuitive, fast, scalable C++ machine learning library (binaries)
 This package contains example binaries using the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: mlpack-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, libjs-jquery
Description: intuitive, fast, scalable C++ machine learning library (documentation)
 This package contains documentation for the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

## Memory consumption issues on some autobuilders have been causing
## build failures.  There are two ways to address such issues:
## (a) reduce parallelism, e.g., dh $@ --max-parallel=2
## (b) reduce GCC memory usage, e.g., g++ --param ggc-min-expand=20 to
## reduce abrupt memory spikes, and g++ -g0 to skip debugging info.

## These issues have occurred post-2.1.x in two places: Ubuntu
## Launchpad, and some particular Debian architectures including
## armhf, mips, mipsel, m68k, kfreebsd-amd64, kfreebsd-i386.

## For that reason, I am activating all of the above space-reduction
## mechanisms on Ubuntu, all 32-bit architectures, and all kfreebsd
## systems.

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
SAVE_SPACE=yes
endif

ifeq ($(shell dpkg-architecture --query DEB_BUILD_ARCH_BITS),32)
SAVE_SPACE=yes
endif

ifeq ($(shell dpkg-architecture --query DEB_BUILD_ARCH_OS),kfreebsd)
SAVE_SPACE=yes
endif

ifeq ($(SAVE_SPACE),yes)
ifneq (, $(filter $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU),mips mipsel))
	export CXX=g++ --param ggc-min-expand=5 -g0
	DH_FLAGS += --max-parallel=1
else
	export CXX=g++ --param ggc-min-expand=20 -g0
	DH_FLAGS += --max-parallel=2
endif
endif

%:
	dh $@ ${DH_FLAGS}

# Previously tweaked inputenc package option from utf8 to utf8x, no longer necesary:
#	 sed --in-place 's:usepackage\[utf8\]{inputenc}:usepackage[utf8x]{inputenc}:' refman.tex &&

# Previously used recursive make to build pdf documentation, that uses
# latex/dvips/ps2pdf the last of which terminated with a mysterious
# perhaps-font-related error, instead now just use latexmk --pdf which
# uses pdflatex.
#	 $(MAKE) pdf

override_dh_auto_build:
	dh_auto_build
	@echo building PDF reference manual
	cd obj-*/doc/latex && \
	 latexmk --pdf refman.tex

override_dh_auto_test:
	@echo do not ask do not tell do not test

override_dh_install:
	dh_install --list-missing
	@echo use shared jquery.js javascript library
	for f in $$(find debian/mlpack-doc -name jquery.js); do \
	  ln --verbose --symbolic --force /usr/share/javascript/jquery/jquery.js $$f; \
	done

override_dh_installchangelogs:
	dh_installchangelogs HISTORY.md

override_dh_compress:
	dh_compress -Xrefman.pdf -Xdoc/html/

## mlpack 3.0.2

=== debian/changelog ===
mlpack (3.0.2-1) unstable; urgency=medium

  * New upstream version
  * Bump policy

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 27 Jun 2018 21:15:19 +0100

mlpack (3.0.1-2) unstable; urgency=medium

  * Tweak debian/rules to use approves mechanisms

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 28 May 2018 14:09:02 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 		libarmadillo-dev,
 		txt2man,
 		doxygen, doxygen-latex, graphviz, latexmk
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: https://www.mlpack.org/
 Vcs-Git: https://salsa.debian.org/science-team/mlpack.git
 Vcs-Browser: https://salsa.debian.org/science-team/mlpack
